
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef demo_TCLSERV_CLIENT_MSG_LIB_H
#define demo_TCLSERV_CLIENT_MSG_LIB_H

#include <server/demoType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int demoTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int demoTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int demoTclservClientSetSpeedRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 DEMO_SPEED *(in_speedRef)
		);

int demoTclservClientSetSpeedReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int demoTclservClientSetSpeedRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 DEMO_SPEED *(in_speedRef) ,
				 
				 int *bilan);




int demoTclservClientGetSpeedRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int demoTclservClientGetSpeedReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       DEMO_SPEED *(out_speedRef),
			       int *bilan);

int demoTclservClientGetSpeedRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 DEMO_SPEED *(out_speedRef),
				 int *bilan);




int demoTclservClientStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int demoTclservClientStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int demoTclservClientStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int demoTclservClientMoveDistanceRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 double *(in_distRef) 
		);

int demoTclservClientMoveDistanceReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int demoTclservClientMoveDistanceRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				double *(in_distRef) ,
				
				int *bilan);

int demoTclservClientMoveDistanceRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					double *(in_distRef) ,
					
					int *bilan);




int demoTclservClientGotoPositionRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 double *(in_posRef) 
		);

int demoTclservClientGotoPositionReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int demoTclservClientGotoPositionRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				double *(in_posRef) ,
				
				int *bilan);

int demoTclservClientGotoPositionRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					double *(in_posRef) ,
					
					int *bilan);




int demoTclservClientMonitorRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 double *(in_monitor) 
		);

int demoTclservClientMonitorReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      double *(out_position),
			      int *bilan);


int demoTclservClientMonitorRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				double *(in_monitor) ,
				double *(out_position),
				int *bilan);

int demoTclservClientMonitorRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					double *(in_monitor) ,
					double *(out_position),
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* demoTCLSERV_CLIENT_MSG_LIB_H */

