
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] demoInstall] >= 0 } {
    interp expose {} demoInstall
}

proc ::demoInstall { name } {
    foreach rqst { "SetSpeed" "GetSpeed" "Stop" "MoveDistance" "GotoPosition" "Monitor" "MobilestatePosterRead" "MobilerefPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} demo$rqst $name
    }
}

interp hide {} demoInstall




# SetSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] demoSetSpeed] >= 0 } {
    interp expose {} demoSetSpeed
}
if { [lsearch [interp hidden] demoSetSpeedFormatOutput] >= 0 } {
    interp expose {} demoSetSpeedFormatOutput
}

proc ::demoSetSpeed { name args } {
    set format {}
    lappend format [list { "DEMO_FAST" "DEMO_SLOW" } "Max required speed in m/s" 0.500000 ]

    return [ ::cs::rqstSend "${name}" "SetSpeed" \
	"To change speed" \
	"DEMO_SPEED speedRef\n" \
	1 \
	$format \
	$args ]
}


proc ::demoSetSpeedFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoSetSpeed
interp hide {} demoSetSpeedFormatOutput





# GetSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] demoGetSpeed] >= 0 } {
    interp expose {} demoGetSpeed
}
if { [lsearch [interp hidden] demoGetSpeedFormatOutput] >= 0 } {
    interp expose {} demoGetSpeedFormatOutput
}

proc ::demoGetSpeed { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSpeed" \
	"To get current speed value" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::demoGetSpeedFormatOutput { list } {
    set format { {} status { } speedRef }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoGetSpeed
interp hide {} demoGetSpeedFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] demoStop] >= 0 } {
    interp expose {} demoStop
}
if { [lsearch [interp hidden] demoStopFormatOutput] >= 0 } {
    interp expose {} demoStopFormatOutput
}

proc ::demoStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stops motion and interrupts all motion requests" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::demoStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoStop
interp hide {} demoStopFormatOutput





# MoveDistance ----------------------------------------------------------

if { [lsearch [interp hidden] demoMoveDistance] >= 0 } {
    interp expose {} demoMoveDistance
}
if { [lsearch [interp hidden] demoMoveDistanceFormatOutput] >= 0 } {
    interp expose {} demoMoveDistanceFormatOutput
}

proc ::demoMoveDistance { name args } {
    set format {}
    lappend format [list double "distance in m" 0 ]

    return [ ::cs::rqstSend "${name}" "MoveDistance" \
	"Move of the given distance" \
	"double distRef\n" \
	1 \
	$format \
	$args ]
}


proc ::demoMoveDistanceFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoMoveDistance
interp hide {} demoMoveDistanceFormatOutput





# GotoPosition ----------------------------------------------------------

if { [lsearch [interp hidden] demoGotoPosition] >= 0 } {
    interp expose {} demoGotoPosition
}
if { [lsearch [interp hidden] demoGotoPositionFormatOutput] >= 0 } {
    interp expose {} demoGotoPositionFormatOutput
}

proc ::demoGotoPosition { name args } {
    set format {}
    lappend format [list double "goto position in m" 0 ]

    return [ ::cs::rqstSend "${name}" "GotoPosition" \
	"Move to the given position" \
	"double posRef\n" \
	1 \
	$format \
	$args ]
}


proc ::demoGotoPositionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoGotoPosition
interp hide {} demoGotoPositionFormatOutput





# Monitor ----------------------------------------------------------

if { [lsearch [interp hidden] demoMonitor] >= 0 } {
    interp expose {} demoMonitor
}
if { [lsearch [interp hidden] demoMonitorFormatOutput] >= 0 } {
    interp expose {} demoMonitorFormatOutput
}

proc ::demoMonitor { name args } {
    set format {}
    lappend format [list double "monitored absolute position in m" 0 ]

    return [ ::cs::rqstSend "${name}" "Monitor" \
	"Monitor the passage on the given position" \
	"double monitor\n" \
	1 \
	$format \
	$args ]
}


proc ::demoMonitorFormatOutput { list } {
    set format { {} status { } position }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoMonitor
interp hide {} demoMonitorFormatOutput





# Mobilestate ----------------------------------------------------------

if { [lsearch [interp hidden] demoMobilestatePosterRead] >= 0 } {
    interp expose {} demoMobilestatePosterRead
}
if { [lsearch [interp hidden] demoMobilestatePosterFormatOutput] >= 0 } {
    interp expose {} demoMobilestatePosterFormatOutput
}

proc ::demoMobilestatePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Mobilestate" \
	"DEMO_STATE_STR\n| double position\n| double speed\n" \
	$args ]
}


proc ::demoMobilestatePosterFormatOutput { list } {
    set format { {} status { } { state { } position { } speed } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoMobilestatePosterRead
interp hide {} demoMobilestatePosterFormatOutput





# Mobileref ----------------------------------------------------------

if { [lsearch [interp hidden] demoMobilerefPosterRead] >= 0 } {
    interp expose {} demoMobilerefPosterRead
}
if { [lsearch [interp hidden] demoMobilerefPosterFormatOutput] >= 0 } {
    interp expose {} demoMobilerefPosterFormatOutput
}

proc ::demoMobilerefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Mobileref" \
	"double ref\n" \
	$args ]
}


proc ::demoMobilerefPosterFormatOutput { list } {
    set format { {} status { } ref }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} demoMobilerefPosterRead
interp hide {} demoMobilerefPosterFormatOutput


